## fwts 19.09.00

=== Makefile ===
#
# Copyright (C) 2012-2019 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

KVER ?= `uname -r`
KBUILD_MODPOST_WARN=y
obj-m += efi_runtime.o
all:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules

install:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules_install

clean:
	make -C /lib/modules/$(KVER)/build M=`pwd` clean

=== debian/changelog ===
fwts (19.09.00-0ubuntu1) eoan; urgency=medium

  [Alex Hung]
  * acpi/boot: skip ACPI BOOT test on UEFI systems.
  * acpi: s3: fix typo from 6b94bb6a4b13e

  [Colin Ian King]
  * opal: add more bounds checking and zero pstates array

  [Ivan Hu]
  * fwtstest: boot-0001: sync with boot table check on efi firmware

 -- Ivan Hu <ivan.hu@ubuntu.com>  Thu, 26 Sep 2019 21:53:07 +0800

fwts (19.08.00-0ubuntu1) eoan; urgency=medium

  [Alex Hung]
  * auto-packager: mkpackage.sh: remove cosmic

  [Colin Ian King]
  * efi_runtime: enable KBUILD_MODPOST_WARN=y to workaround build failures
  * ACPICA: Update to version 20190816
  * fwtstest: syntaxcheck-0001: update to keep in sync with ACPICA features

  [Naresh Bhat]
  * README: Add package dependency notes for ARM64

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 27 Aug 2019 12:54:13 +0800

fwts (19.07.00-0ubuntu1) eoan; urgency=medium

  [Alex Hung]
  * cpu/msr: skip read-only MCG_CAP MSR
  * cpu/msr: add document info the cpu_msr_map table
  * cpu/msr: add 3 more CPU IDs for IA32_silvermont_MSRs
  * cpu/msr: remove EBL_CR_POWERON (2ah) from IA32_MSRs
  * cpu/msr: check SGX & LMCE in IA32_FEATURE_CONTROL (3ah)
  * cpu/msr: move TSC_ADJUST (3bh) to IA32_MSRs
  * cpu/msr: add SMM_MONITOR_CTL (9bh) to IA32_MSRs
  * cpu/msr: update MTRRCAP MSR register
  * cpu/msr: update PAT MSR PA0[2:0]
  * cpu/msr: add MC*_CTL2 MSR registers
  * cpu/msr: update fields for MTRR_DEF_TYPE MSR
  * cpu/msr: add VMX_VMFUNC MSR register
  * cpu/msr: remove same MSR registers in IA32_MSRs
  * cpu/msr: add MISC_ENABLE MSR to IA32_atom_MSRs
  * cpu/msr: remove MSR for Error-Reporting Register Banks
  * cpu/msr: add MSR_PMG_IO_CAPTURE_BASE to IA32_silvermont_MSRs
  * cpu/msr: add MSR_FEATURE_CONFIG to IA32_silvermont_MSRs
  * cpu/msr: add MSR_TEMPERATURE_TARGET to IA32_silvermont_MSRs
  * cpu/msr: add MSR_BBL_CR_CTL3 to IA32_silvermont_MSRs
  * cpu/msr: update THERM_INTERRUPT MSR masks
  * cpu/msr: update MISC_ENABLE to IA32_silvermont_MSRs

  [Colin Ian King]
  * Move libfwtsacpica and libfwtsiasl into their own directories
  * Makefiles: hard code paths to workaround autotool bug
  * ACPICA: Update to version 20190703
  * fwts-test: arg-help-0001: reset tty width to original setting
  * lib: fwts_framework: fix memory leak on fw->fdt
  * fwts: opal: fix memory leak of 'buf'.
  * acpi: method: skip over bad method_handle and failed message type
  * acpi: method: add null pointer sanity checks on resource
  * acpi: method: add more null pointer sanity checks on resource
  * acpi: s3/s4: initialize error to zero
  * lib: fwts_pipeio: zero pollfds to squish a static analysis warning

  [Erico Nunes]
  * dsddump: fix segfault on type ACPI_TYPE_LOCAL_REFERENCE

 -- Alex Hung <alex.hung@ubuntu.com>  Thu, 25 Jul 2019 10:48:59 -0600

fwts (19.06.00-0ubuntu1) eoan; urgency=medium

  [Alex Hung]
  * acpi/fadt: update latest FADT revision to 6.3
  * apic: apicedge: remove irq < 16 is edge only
  * mtrr: set severity to critical for incorrect attributes

  [Colin Ian King]
  * acpi: s3: fix two memory leaks on fwts_get() calls and minor clean-ups
  * fwts_summary: check for list creation failure
  * fwts_modprobe: fix potential null pointer dereference
  * cpu: cpufreq: avoid division by zero by initializing cpu_top_perf to 1
  * fwts_args: check for null text pointer
  * fwts_log_plaintext: check for null pointer
  * acpi: s3: check for null pointer
  * lib: fwts_cpu: only assign a string if it has not yet been assigned
  * acpi: syntaxcheck: nullify pointers to clean up static analysis warnings
  * lib: fwts_log_scan: ensure accumulated error count is initialized
  * lib: fwts_acpi_tables: remove redundant initialization of ret
  * acpi: tcpa: remove redundant initialization of boolean passed
  * acpi: dscdump: reduce scope of loop counter i
  * acpi: method: reduce scope of boolean flag matching_levels
  * lib: fwts_formatting: use simpler style for assigments
  * uefi: uefirttime: make status static, cleans up cppcheck warnings

  [Erico Nunes]
  * dsddump: fix Package loop condition

  [Ivan Hu]
  * uefitime: add checking the EFI_UNSUPPORTED return code
  * uefirtvariable: add checking the EFI_UNSUPPORTED return code
  * uefirtmisc: add checking the EFI_UNSUPPORTED return code

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 12 Jun 2019 10:24:53 -0700

fwts (19.05.00-0ubuntu1) eoan; urgency=medium

  [Alex Hung]
  * auto-packager: mkpackage.sh: remove trusty
  * dmicheck: update supported SMBIOS version
  * acpi/method: check full and battery power if acpi_video0 exists
  * dmicheck: checks type length vs. SMBIOS versions
  * dmicheck: add Type 1's Field 25 & 26 as used by kernel
  * apic: apicedge: fix typo in error messages
  * cpufreq: change from abort to skip when cpufreq cannot run
  * kernel:version: change ACPI version to ACPICA version
  * pci:crs: fix an indentation error
  * acpi: s3: check sleep type for output messages

  [Colin Ian King]
  * snapcraft: update to core18
  * ACPICA: Update to version 20190329
  * Add libbsd to travis build file
  * ACPICA: Update to version 20190405
  * acpica: re-work fwts / iasl interface to work with latest ACPICA
  * fwts-test: refresh syntaxcheck test output
  * ACPICA: Update to version 20190509
  * fwts-test/syntaxcheck: refresh syntaxcheck test output
  * fwts_acpica: don't add in RSDP or null table entries to XSDT or RSDT (LP: #1829167)

  [Ivan Hu]
  * auto-packager:mkpackage.sh: add eoan

  [fanjinke]
  * Add support for Hygon Dhyana CPU

 -- Ivan Hu <ivan.hu@ubuntu.com>  Thu, 16 May 2019 16:27:44 +0800

## fwts 20.02.00

=== debian/changelog ===
fwts (20.02.00-0ubuntu1) focal; urgency=medium

  [Alex Hung]
  * fwts_hwinfo: add device check for Type-C
  * fwts_hwinfo: fix copy & paste typos
  * fwts_hwinfo: add device check for disks
  * fwts_hwinfo: add device check for attached monitors
  * live-image: replace hard-coded "oem-tests.lst" by a variable
  * live-image: add an option for creating oem-tests.lst

  [Colin Ian King]
  * ACPICA: Update to version 20200214
  * fwts-test/syntaxcheck: sync regression log with latest ACPICA output

  [Ivan Hu]
  * auto-packager: mkpackage.sh: remove disco

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 26 Feb 2020 09:39:35 +0800

fwts (20.01.00-0ubuntu1) focal; urgency=medium

  [Alex Hung]
  * dmicheck: skip type 17 test if no memory module

  [Colin Ian King]
  * ACPICA: Update to version 20191213
  * Update copyright year to 2020
  * ACPICA: Update to version 20200110
  * lib: fwts_memorymap: check for memory allocation failure on object entry
  * lib: fwts_multiproc: add sanity check to data->size to clean up static analysis warning
  * lib: fwts_acpi_tables: remove redundant initialization to oem_tbl_id
  * uefirtvariable: indicate that return from setvariable_insertvariable is ignored
  * lib: fwts_memorymap: fix resource leak on dir on error return path

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 14 Jan 2020 15:32:20 +0800

fwts (19.12.00-0ubuntu1) focal; urgency=medium

  [Colin Ian King]
  * efi_runtime: don't build dkms module for kernels 4.8.0 and above
    (LP: #1853090)
  * debian/tests: only run dkms test when dkms module is run
  * debugger: check for memory allocation failure on object Elements
  * debugger: fix spelling mistake "adress" -> "address"
  * cpu: microcode: remove redundant check on pointer entry
  * fwts_wakealarm: remove unused function fwts_wakealarm_exits

  [Erik Schmauss]
  * iASL: remove unneeded NULL checks

 -- Alex Hung <alex.hung@ubuntu.com>  Sun, 08 Dec 2019 22:01:38 -0700

fwts (19.11.00-0ubuntu1) focal; urgency=medium

  [Alex Hung]
  * lib: fwts_log_html: tweak line-height
  * auto-packager:mkpackage.sh: add focal
  * acpi/s3: fine-tune measure of suspend time
  * lib: fwts_log_html: set max-width for line wrap
  * live-image: overwrite pre-defined tests by oem-tests.lst
  * acpi/s3: fix no suspend & resume time for s2idle
  * acpi/fadt: check no-zero failures for X_PM* for 6.1 and before
  * sbbr: add uefi tests to ARM's SBBR

  [Colin Ian King]
  * ACPICA: Update to version 20191018
  * iASL: fix memory leak of LocalityBuffer on error return path
  * lib: fwts_framework: use strlcpy instead of strncpy, fixes gcc-10 build
    errors

  [Ivan Hu]
  * ebbr: add EBBR option for ARM embedded systems
  * fwts-tests: sync up with --ebbr option
  * lib: move the global variable guid to lib header
  * lib: add function for check the RuntimeServicesSupported variable
  * uefirttime: add unsupported checking with RuntimeServicesSupported variable
  * uefirtvariable: add unsupported checking with RuntimeServicesSupported
    variable
  * uefirtmisc: add unsupported checking with RuntimeServicesSupported variable
  * doc: add --ebbr option for man page

  [Robert Moore]
  * iASL: Use ACPI_COMPARE_NAMESEG instead of strcmp

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 13 Nov 2019 22:06:27 -0700

## fwts 20.03.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2012-2019 Canonical, Ltd.
+# Copyright (C) 2012-2020 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License

## fwts 20.09.00

=== debian/changelog ===
fwts (20.09.00-0ubuntu1) groovy; urgency=medium

  [Alex Hung]
  * s0idle: add a test to verify lower power s0 idle is enabled
  * fwts-test: sync up with new s0idle tests

  [Colin Ian King]
  * s3: fix segmentation fault when PM_S2IDLE_SLP_S0 is not available
    (LP: #1894229)

  [Ivan Hu]
  * tpmevlogdump: add dumping sha1 log format event log

 -- Alex Hung <alex.hung@ubuntu.com>  Thu, 17 Sep 2020 12:07:19 -0600

fwts (20.08.00-0ubuntu1) groovy; urgency=medium

  [Alex Hung]
  * gitignore: update ignore files
  * acpi/fadt: checks X_GPE0/1 have byte access width
  * s3: check slp_s0_residency_usec for s2idle

  [Colin Ian King]
  * Debian: update compat level and standards version to match Xenial
  * Debian/copyright fix lintian warning
  * Debian: add riscv64 lintian overrides
  * data: klog.json: fix unintential newline in a literal string
  * dmicheck: update Memory Device type 17 size/version check (LP: #1892479)
  * Replace json-c library with minimal replacement
  * Remove all libjson references
  * lib: fwts_json: fix memory leak on error return path
  * lib: fwts_log_json: fix memory leak

 -- Alex Hung <alex.hung@ubuntu.com>  Mon, 24 Aug 2020 21:53:07 -0600

fwts (20.07.00-0ubuntu1) groovy; urgency=medium

  [Alex Hung]
  * auto-packager: mkpackage.sh: remove eoan
  * travis: update dist to focal
  * tpm2: table size can be 76 when "LAML" & "LASA" are used

  [Colin Ian King]
  * replace inaccurate and offsensive language
  * acpi: mpst: fix potential infinite loop on 16 bit counter j
  * tpmevlogdump: fix leak of fd on error return paths, voidify close returns
  * opal: add check for the number of regions
  * ACPICA: Update to version 20200717
  * Add riscv64 architecture to fwts
  * lib: fwts_modprobe: add helper to build module path name
  * lib: fwts_battery: add helper to build battery path name

  [Ivan Hu]
  * tpmevlogdump: add function for dumping tpm event log
  * tpmevlogdump: add pcr_index usage
  * libfwtsiasl: fix build error on groovy
  * lib: fwts_battery: fix build error on armhf
  * lib: fwts_buttion: add helper function to build button path

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 29 Jul 2020 15:30:01 +0800

fwts (20.06.01-0ubuntu1) groovy; urgency=medium

  [Alex Hung]
  * fwts_acpi_object_eval: add a function to check package
  * acpi/method: remove duplicated code by a common function
  * acpi: refactor method_test_BMD to a common function
  * fwts_acpi_object_eval: add a function to check buffer size
  * acpi/method/time: replace buffer size checks with function calls
  * method: fix typo for ROM test return
  * acpi/method: add tests for _MAT method
  * fwts-test: sync up with _MAT method tests
  * method: replace duplicated code by util function in _PRR test
  * acpi/method: remove duplicated code in _PSR test
  * acpi/method: add tests for _SLI method
  * fwts-test: sync up with _SLI method tests
  * acpi/method: fix incorrect error messages for _SUB tests
  * acpi/method: check _WPP returns by fwts_method_test_polling_return
  * acpi/method: update tested method comments for _ALx and _SLI
  * acpi/method: line wrap long statements
  * dmicheck: update supported DMI version to 3.3
  * fwts_acpi_object_eval: revise fwts_method_test_passed_failed_return
  * dmicheck: test feature flags in type 2
  * dmicheck: remove duplicated chassis type test in type 3
  * dmicheck: update Processor Characteristics test in type 4
  * dmicheck: add Supported SRAM test in type 4
  * dmicheck: fix typo in type 8
  * dmicheck: add CXL Flexbus 1.0 to slot type in type 9
  * dmicheck: fix wrong length for reserved fields in type 13
  * dmicheck: update tests in type 17
  * dmicheck: check fields that has max 0x8000
  * dmicheck: check reserved bits in Characteristics in type 43
  * dmicheck: refactor code to check mutliple valid ranges
  * fwts_acpi_tables: fix fwts_get_acpi_version helper
  * acpitables: test ACPI versions vs. ACPI table revisions
  * fwts-test: sync up with acpitables tests
  * gitignore: update ignore list
  * cpu: virt: remove unused marco "CPUID_FAM_REV"
  * acpi/nvdimm: add tests for nvdimm devices
  * acpi/devices: refactor devices' HIDs and names
  * cpu/msr: remove General Performance Counters
  * acpi/devices: fix typos in comments
  * dmicheck: add type 0's fields used by kernel
  * acpitables: add table name outputs to revision tests
  * fwts-collect: depreciate ebda collection

  [Colin Ian King]
  * ACPICA: Update to version 20200528

  [Ivan Hu]
  * lib: fwts_acpi_tables: add option for dump acpi table from sysfs
  * lib: fwts_dump_data: make the dumping data the same format as acpidump
  * doc: add new --dump-acpi-from-sysfs option
  * fwts-test: sync up with new --dump-acpi-from-sysfs option and acpidump changes
  * lib: fwts_acpi_object_eval: fix build error on i386

  [You-Sheng Yang]
  * gitignore: add git.mk
  * debian: update copyright info for git.mk
  * gitignore: enable git.mk usage
  * gitignore: add results.log
  * gitignore: add packaging specific files

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 23 Jun 2020 16:37:55 +0800

fwts (20.05.00-0ubuntu1) groovy; urgency=medium

  [Alex Hung]
  * dmicheck: update system slot type (type 9)
  * dmicheck: update Memory Device type (type 17)
  * dmicheck: add Type 44 (Processor Additional Information)
  * dmicheck: update Memory Array Location (type 16)
  * acpi/method: check _PS3 exists when _PS0 is present
  * klog.json: add a "Unable ... IOMMU perf counter" message
  * acpi/method: checks _UPP's return as polling
  * acpi/method: add tests for _ALx method
  * fwts-test: sync up with _ALx control method
  * acpi/method: reuse common function for _PCL method
  * acpi/method: refactor with fwts_method_test_all_reference_package_return
  * acpi/method: check reserved bits from _BBN return
  * acpi/method/battery: replace hardcoded array length by FWTS_ARRAY_SIZE
  * acpi/method: remove duplicated code for returned integers
  * fwts-test: sync up with method tests


## fwts 21.03.00

=== debian/changelog ===
fwts (21.03.00-0ubuntu1) hirsute; urgency=medium

  [Alex Hung]
  * pci: move pci_device struct to fwts_pci.h
  * bios: smm: add a test to check SMM lock bits
  * bios: interrupt: add a test to check ACPI SCI per second
  * acpi: uniqueid: add tests for _HID/_CID vs. _UID

  [Colin Ian King]
  * acpi: s3,s4: ensure status is initialized

  [Heinrich Schuchardt]
  * uefi: update header for EFI runtime services
  * uefi: fix fwts_uefi_rt_support_status_get()

  [Ivan Hu]
  * uefi: remove the var_ prefix
  * uefi: move fwts_uefi_rt_support_status_get to init function

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 29 Mar 2021 16:55:04 +0800

fwts (21.02.00-0ubuntu1) hirsute; urgency=medium

  [Alex Hung]
  * acpi: replace objname by get_object_name() in various functions
  * acpi: method: remove a redundant passed message
  * acpi: move acpi battery common methods to lib
  * acpi: method: check fixed package by fwts_method_package_elements_type
  * acpi: method: merge and refine _CSD, _PSD and _TSD return tests
  * lib: fwts_acpi_object_eval: add returns to long lines
  * acpi: method: refine _PSS and _TSS method tests
  * acpi: method: merge _PCT & _PTC method tests
  * acpi: method: refine tests sub-package elements
  * acpi: method: remove redundant count_equal checks in _CPC test
  * acpi: method: refine _Sx count checks by fwts_method_package_count_min
  * acpi: method: refine _PRW method tests
  * acpi: method: add passed messages to _GLK and _DSD tests
  * acpi: update ACPI version to 6.4
  * acpi/madt: add ACPI 6.4 to madt_revision test
  * lib: fwts_acpi_tables: update fwts_get_acpi_version (mantis: 2105)
  * acpitables: update ACPI table revsion test to ACPI 6.4
  * acpi: nfit: add Spa Location Cookie as in ACPI 6.4 (mantis 1988)
  * acpi: srat/hmat: update fields of sub-structures (mantis 1991)
  * acpi: battery/method: add _BPC, _BPS and _BPT tests (mantis 1997)
  * fwts-test: sync up with _BPC, _BPS, _BPT, NFIT and HMAT tests
  * acpi: pcct: add type 5 according to ACPI 6.4 (manti 2010)
  * fwts-tests: sync up with pcct updates
  * acpi: method: add _CBR test (mantis 2045/2077)
  * fwts-test: sync up with _CBR test
  * acpi: madt: add Multiprocessor Wakeup support (mantis 2087)
  * acpi: battery: add Battery Charge Limiting (mantis 2090)
  * acpi: method: update _DDC argument size (mantis 2137)
  * acpi: madt: update fadt and madt revisions to ACPI 6.4
  * lib: acpi: add a macro to fwts_acpi_reserved_bits_check
  * lib: acpi: add a macro to fwts_acpi_reserved_zero_check
  * fwts_framework: skip sbbr & ebbr on non-aarch64 systems
  * sbbr: disable SBBR tests on non-aarch64 systems
  * pci: maxreadreq: Add "safe to ignore ... message"
  * version: remove /proc/acpi/info
  * Revert "lib: fwts_acpi_tables: add option for dump acpi table from sysfs"
  * lib: acpi: load acpi tables from sysfs by default
  * fwts-test: sync up with removal of dump-acpi-from-sysfs

  [Colin Ian King]
  * acpi: method: fix two memory leaks on error return paths
  * lib: fwts_acpi_tables: use bit-wise & rather than logical &&

 -- Alex Hung <alex.hung@ubuntu.com>  Tue, 23 Feb 2021 11:49:17 -0700

fwts (21.01.00-0ubuntu1) hirsute; urgency=medium

  [Alex Hung]
  * cpu: maxfreq: skip when "model name" is not available
  * acpi: enable & disable acpi tables for arm64
  * acpi: lib: refactor table _init to a macro function
  * fwts-test: sync up with XSDT revision changes
  * Update copyright year to 2021
  * acpi: check reserved fields by fwts_acpi_reserved_zero_check
  * fwts-test: sync up with fwts_acpi_reserved_zero_check
  * acpi: fix incorrect parameter to fwts_acpi_reserved_bits_check
  * lib: add fwts_acpi_fixed_value_check function to check fixed values
  * acpi: refactor checks for fixed values by fwts_acpi_fixed_value_check
  * fwts-test: sync up with fwts_acpi_fixed_value_check
  * acpi: add fwts_acpi_space_id_check to check GAS adrress space ids
  * fwts-test: sync up with fwts_acpi_space_id_check
  * acpi: mcfg: enable only if ACPI is available
  * cpu: maxfreq: fix build errors on arm32 + gcc10
  * lib: add fwts_log_info_simp_int to printing integers
  * fwts-test: sync up with fwts_log_info_simp_int changes
  * lib: fwts_smbios: merge similar functions
  * dmicheck: add a marco to shorten dmi_ranges_uint8_check calls
  * acpi: pmtt: fix infinite loops when length is incorrectly zero
  * lib: fix compile error for debian + gcc 8.3
  * acpi: method: add a function to check number of sub-package elements
  * acpi: method: replace _GPE test by fwts_method_package_elements_type
  * acpi: method: add a function to check type of sub-package elements
  * acpi: shorten fwts_method_package_elements_type args by a macro

  [Colin Ian King]
  * ACPICA: Update to version 20201217
  * ACPICA: Update to version 20210105
  * acpi: fix incorrect method of finding string size
  * uefi: add a helper to check for address overflow
  * tpmevlog: clean up some minor cppcheck style warnings
  * tpmevlogdump: clean up some minor cppcheck style warnings
  * uefi: clean up a cppcheck style warning
  * kernelscan: fix variable shadowing warning
  * cpu: cpufreq: initialize online_cpus in for loop
  * acpi: add null check on calls to get_space_id_name()
  * acpi: fix check of length overflow

  [Nhi Pham]
  * acpi: lib: correct revision of the fake XSDT table

  [Rebecca Cran]
  * dmicheck: Type 4 Processor Characteristics bit 9 is no longer reserved

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 20 Jan 2021 01:31:17 -0700

fwts (20.12.00-0ubuntu1) hirsute; urgency=medium

  [Alex Hung]
  * acpi: method: define marcos for D3hot and D3cold
  * acpi: fadt: X_GPE0/1_BLK can be zero when not used
  * pci: maxreadreq: skip Intel video devices
  * acpi: method: replace revision checks by fwts_method_test_revision
  * dmicheck: add dmi version check to SMBIOS3
  * lib: fwts_acpi_object_eval: add fwts_method_test_revision function
  * lib: fix a function name typo in comment
  * dmi: dmicheck: update type 4, 9 and 17 according to spec 3.4


=== debian/control ===
Source: fwts
Section: devel
Priority: optional
Maintainer: Firmware Testing Team <fwts-devel@lists.ubuntu.com>
Uploaders: Colin King <colin.king@ubuntu.com>, Alex Hung <alex.hung@canonical.com>, Ivan Hu <ivan.hu@canonical.com>
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9~),
               autoconf,
               automake,
               libtool,
               flex,
               bison,
               dh-autoreconf,
               dkms,
               libglib2.0-dev,
               pkg-config,
               libfdt-dev,
               libbsd-dev

Package: fwts
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: libfwtsiasl1 (= ${binary:Version}),
         libfwtsacpica1 (= ${binary:Version}),
         libfwts1 (= ${binary:Version}),
         fwts-efi-runtime-dkms (= ${binary:Version}) [amd64],
         ${shlibs:Depends},
         ${misc:Depends},
         pciutils,
         device-tree-compiler [ppc64el powerpc]
Suggests: dmidecode
Description: FirmWare Test Suite
 This is a firmware test suite that performs sanity checks on system
 firmware. It is intended to identify BIOS and ACPI errors and 
 if appropriate it will try to explain the errors and give advice to 
 help workaround or fix firmware bugs.  It is primarily intended to 
 be a Linux-centric firmware troubleshooting tool.

Package: libfwtsiasl1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FirmWare Test Suite ACPICA core built for iasl functionality
 The firmware test suite requires the ACPICA core engine to be built in
 compiler mode (with ACPI_ASL_COMPILER enabled) to support assembly and 
 disassembly of ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
 This library contains this code with a thin fwts specific API to 
 interface with fwts.

Package: libfwtsacpica1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FirmWare Test Suite ACPICA core built for acpiexec functionality
 The firmware test suite requires the ACPICA core engine to be built in
 execution mode (with ACPI_EXEC_APP enabled) to support run time execution
 of ACPI Machine Language (AML) in the ACPI DSDT and SSDTs. This library
 contains this code with a thin fwts specific API to interface with fwts.

Package: libfwts1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FirmWare Test Suite core support library
 This is the fwts core library. It contains a top level test framework
 and a rich range of firmware specific testing support code for the 
 various fwts tests.

Package: fwts-frontend
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Priority: optional
Depends: ${misc:Depends},
         dialog,
         fwts
Description: Firmware Test Suite frontend interface
 This is a dialog based interface designed to provide an easy to use method
 to execute tests via Firmware Test Suite and is also used as the primary 
 interface within Firmware Test Suite live images.

Package: fwts-efi-runtime-dkms
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el
Priority: optional
Depends: ${misc:Depends},
         dkms
Description: Firmware Test Suite UEFI Runtime Service kernel driver
 This package provides the efi_runtime kernel driver in DKMS format,
 which is required for accessing UEFI Runtime Services.

## fwts 21.09.00

=== debian/changelog ===
fwts (21.09.00-0ubuntu1) impish; urgency=medium

  [Alex Hung]
  * lib: fwts_firmware: fix incorrect comments for fwts_firmware_detect
  * acpi: replace fwts_firmware_detect() by fw->firmware_type

  [Colin Ian King]
  * Manual: update number of tests, date and remove double spaces
  * lib: use <poll.h> rather than <sys/poll.h>
  * snapcraft: update to use core20
  * fwts_acpi_tables: NULLify table pointers
  * fwts_devicetree: clean up static analysis warning
  * opal: mem_info: clean up pedantic static analysis warnings
  * uefirtvariable: clean up pedantic static analysis warnings
  * acpi: s3power: clean up pedantic static analysis warnings
  * opal: Fix a few memory leaks on asprint allocated buffers
  * opal: clean up some coding style issues
  * smccc_test: fix missing ) in pr_info call
  * acpi: cstates: remove redundant null check on entry
  * acpi: dmar: constify a pointer argument in acpi_parse_dev_scope
  * acpi: iort: constify some function arguments
  * bios: smm: remove redundant variable n
  * src/pci/smccc: reduce scope of variable ret
  * uefi: securebootcert: make some function arguments const
  * uefi: uefirtmisc: reduce scope of some variables

  [Rob Herring]
  * Enable dt_sysinfo test for Power only
  * fwts_firmware: Rework Devicetree firmware detection
  * debian/control: Add device-tree-compiler as dependency for
    armel/armhf/arm64 

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 27 Sep 2021 13:49:22 +0800

fwts (21.08.00-0ubuntu1) impish; urgency=medium

  [Alex Hung]
  * sbbr: remove pm_file test (not required in BBR 1.0)
  * acpi/wmi: update WMI known GUIDs from Linux kernel 5.14-rc1
  * fwts-test: sync up with updates in fwts_wmi_known_guids
  * acpi: dmar: add a warning when PCI device is not found
  * acpi: fadt: clarify comments of FACS and HW-reduced mode
  * acpi: fadt: remove hard-coded FADT version
  * lib: fwts_acpi_tables: add a function to get FADT versions
  * acpi: sbbr: refactor by fwts_get_fadt_version
  * bios: smm: fix indentation

  [Colin Ian King]
  * ACPICA: Update to version 20210730
  * ARM64 SMCCC firmware API tests

  [Sunny Wang]
  * uefirttime: Fix incorrect error messages for invalid time test

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 25 Aug 2021 13:47:49 +0800

fwts (21.07.00-0ubuntu1) impish; urgency=medium

  [Alex Hung]
  * acpi: acpitables: add advices for table revision tests
  * sbbr: acpitables: add new recommended tables
  * fwts_acpi_tables: skip FACS warning for reduced hardware
  * fwts-test: sync up with DBG2 changes from BSA updates
  * auto-packager: mkpackage.sh: remove groovy

  [Erico Nunes]
  * sbbr: remove SSDT from mandatory list
  * sbbr: adjust signature name for MADT

  [Grzegorz Bernacki]
  * acpi: method: Make method_test_ADR() optional
  * acpi: dbg2: Allow 16550 compatible serial port in DBG2
  * acpi: method: Make _AEI test optional for SBBR

  [Ivan Hu]
  * uefirttime: add advice for the timezone 2047 failure (LP: #1933503)

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 14 Jul 2021 16:56:22 -0600

fwts (21.06.00-0ubuntu1) impish; urgency=medium

  [Alex Hung]
  * fwts_test: arg-json-0001: use current klog.json, not a copy
  * lib: fwts_acpi_tables: constify read-only function arguments
  * fwts_framework: clean up flag macros
  * acpi: pptt: constify read-only function arguments
  * acpi: wdat: enable printing fields
  * fwts-test: sync up with wdat changes
  * acpi: wrap long funtion definitions
  * acpi/fwts-test: fix typo (depreciated->deprecated)
  * sbbr: add checks for mandatory tables
  * sbbr: update recommended tables
  * acpi: remove SBBR mandatory tests in various tables
  * acpi: sbbr: add mcfg and pptt to --sbbr option
  * live-image: remove unnecessary -skip-test=s3,s4 argument
  * live-image: create a separate menu for arm64/aarch64
  * dmicheck: add type 42 to SBBR requirement
  * klog.json: check IRQ requests on irqchip
  * tpmevlog: add to batch tests
  * live-image: add utils tests to "Selected" menu
  * live-image: add "TPM tests" to root menu
  * auto-packager: mkpackage.sh: remove xenial

  [Colin Ian King]
  * Makefile.am: remove all traces of $srcdir and $top_srcdir in Makefile.am
    (LP: #1929138)
  * ACPICA: Update to version 20210604
  * fwts-test: sync test logs with latest ACPICA
  * snapcraft.yaml: add architectures info to make remote snap builds easier
  * Debian: remove spaces at end of lines of changelong
  * Debian: remove spaces at end of lines of control file
  * debian/copyright: use secure https url specifier
  * Debian: add project Homepage field to control file
  * Debian: add Rules-Requires-Root field to control file
  * Debian: update compat level to 9
  * Debian: control: update Standards-Version to 4.1.0
  * Add lintian overrides for ldconfig trigger warning
  * Debian: move source lintian overrides file to source
  * Remove complex disabling of ACPI for non-ACPI targets
  * fwts_acpi_tables: memcpy 4 char ACPI table name

  [Ivan Hu]
  * uefirttime: set test time for the settime and setwakeuptime tests
    (LP: #1929509)

 -- Alex Hung <alex.hung@ubuntu.com>  Sun, 20 Jun 2021 23:42:45 -0600

fwts (21.05.00-0ubuntu1) impish; urgency=medium

  [Alex Hung]
  * acpi: sdev: update type 1 in ACPI 6.4 (mantis 2111)
  * fwts-test: sync up with sdev changes
  * acpi: acpitables: add revision tests for PPTT
  * acpi: pptt: add cache id according to ACPI 6.4 (mantis 2138)
  * acpi: lib: add two helper functions
  * acpi: phat: add a test for PHAT table
  * fwts-test: sync up with phat test
  * oops: add "kernel BUG" to oops test
  * fwts-test: sync up with oops tests
  * acpi: pmtt: update PMTT to revision 2 (mantis 1975)
  * fwts-test: sync up with PMTT rev 2 changes
  * acpi: refactor by fwts_acpi_structure_range_check
  * acpi: refactor by fwts_acpi_reserved_type_check
  * acpi: refactor zero length by fwts_acpi_structure_length_zero_check
  * acpi: refactor length check by fwts_acpi_structure_length_check
  * fwts-test: sync up with PMTT refactoring changes


## fwts 22.03.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2012-2020 Canonical, Ltd.
+# Copyright (C) 2012-2021 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License

=== debian/tests/control ===
Test-Command: [ -e /lib/modules/$(uname -r)/updates/dkms/efi_runtime.ko ] && /usr/lib/dkms/dkms-autopkgtest || true
Restrictions: needs-root, allow-stderr
Depends: dkms

## fwts 22.09.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2012-2021 Canonical, Ltd.
+# Copyright (C) 2012-2022 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License

=== debian/changelog ===
fwts (22.09.00-0ubuntu1) kinetic; urgency=medium

  [Ivan Hu]
  * acpi: dbg2: update the subtype for DBG2 table
  * lib: acpi: update battery charge limiting state for _BST
  * uefi: securebootcert: fix the attribute set for AuditMode and DeployedMode
  * acpi: fadt: get _CST c2 c3 for p_lvl2 and p_lvl3 tests
  * acpi: nhltdump: add dumping nhlt table for audio configurations
  * acpi: nhltdump: add endpoint discriptor string description
  * acpi: svkl: add test for SVKL table (mantis 2162)
  * fwts-test: add regression test for SVKL
  * acpi: iort: remove redundant code

 -- Ivan Hu <ivan.hu@ubuntu.com>  Thu, 22 Sep 2022 09:29:58 +0800

fwts (22.07.00-0ubuntu1) kinetic; urgency=medium

  [Ivan Hu]
  * dmicheck: add Processor Architecture Types check for type 44
  * dmicheck: update for supporting DMI version to 3.5
  * dmicheck: update the processor upgrade field for type 4
  * acpi: pmtt: fix the wrong table label
  * fwts-test: sync up the fix of pmtt wrong table label
  * acpi: asf: remove the checking of minmun watchdog reset value 0
  * fwts-test: sync up the remove of ASF minimun watchdog reset value
  * acpi: asf: enable verbose output
  * fwts-test: sync up with asf verbose dump
  * auto-packager: mkpackage.sh: remove impish

  [orbea]
  * build: Improve linking

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 25 Jul 2022 11:12:56 +0800

fwts (22.05.00-0ubuntu1) kinetic; urgency=medium

  [Colin Ian King]
  * ACPICA: Update to version 20220331

  [Ivan Hu]
  * acpi: iort: update IORT node revision check
  * acpi: iort: update the IORT node dump
  * Update copyright year to 2022
  * acpi: iort: update IORT test to specification version E.d
  * auto-packager:mkpackage.sh: add kinetic
  * acpi: mcfg: checking kernel lockdown when doing mmap PCI config space
  * fwts-test: sync up IORT test with specification version E.d

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 23 May 2022 13:51:46 +0800

fwts (22.03.00-0ubuntu1) jammy; urgency=medium

  [Alex Hung]
  * acpi/time: skip a number of TAD methods when _GCP[0] is clear

  [Colin Ian King]
  * ACPICA: Update to version 20211217
  * fwts-tests: update acpi dump data to be in sync with latest ACPICA

  [Ivan Hu]
  * uefirtmisc: add checking the resources for testing
  * uefirtmisc: add option to specify iterations get next high monitonic count
  * fwts-test: sync up the adding option for get next high monotonic count
  * acpi:dmar: update the link of DMAR table
  * acpi: macf: report failures instead of just logging the errors
  * acpi: sdev: add checking secure access components
  * fwts-test: sync up the sdev checking secure access components

 -- Ivan Hu <ivan.hu@ubuntu.com>  Thu, 17 Mar 2022 14:09:40 +0800

fwts (22.01.00-0ubuntu1) jammy; urgency=medium

  [Alex Hung]
  * auto-packager: mkpackage.sh: remove hirsute
  * s3: use system suspend default if --s3-sleep-type is not used
  * fwts_acpica: skip unneccessary null check

  [Ivan Hu]
  * lib: fwts_tpm.h: add new type definition
  * tpmevlog: add supporting several new types for event log checking
  * tpmevlogdump: add supporting several new types for event log dumping

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 25 Jan 2022 11:37:31 +0800

fwts (21.12.00-0ubuntu1) jammy; urgency=medium

  [Alex Hung]
  * s3: fix incorrect error messages for s2idle_residency
  * s3: increase s2idle_residency to u64 to avoid overflows
  * dmicheck: skip scanning smbios in /dev/mem on aarch64

  [Ivan Hu]
  * s4: clean up pedantic static analysis warnings
  * acpi: uniqueid: clean up pedantic static analysis warnings

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 15 Dec 2021 14:39:16 -0700

fwts (21.11.00-0ubuntu1) jammy; urgency=medium

  [Alex Hung]
  * acpi: uniqueid: skip comparison of _HID and _CID of the same device
  * auto-packager:mkpackage.sh: add jammy

  [Colin Ian King]
  * snapcraft: fix path to fwts
  * snapcraft: Fix incorrect core20 library path

  [G Edhaya Chandran]
  * lib: fwts_smbios: fix loading SMBIOS table from uefi

  [Grzegorz Bernacki]
  * acpi: madt: De-initialise ACPICA core engine in case of error.

  [Ivan Hu]
  * ACPICA: Update to version 20210930
  * s3: add sleep type setting for testing with s3 or s2idle
  * fwts-test: sync up the adding sleep type for s2idle testing

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 24 Nov 2021 00:15:47 -0700

## fwts 23.01.00

=== debian/changelog ===
fwts (23.01.00-0ubuntu1) lunar; urgency=medium

  [Ivan Hu]
  * acpi: s3: fix the issue for determining time to resume
  * tpmevlog: add tests for checking the UEFI_IMAGE_LOAD_EVENT Structure
  * acpi: aest: add tests for ACPI AEST table
  * fwts-test: add regression tests for AEST
  * lib: fwts_acpi_tables: fix the passed reserved value
  * Update copyright year to 2023
  * fwts-test: sync up with the fix of passed reserved value

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 16 Jan 2023 12:08:07 +0800

fwts (22.11.00-0ubuntu1) lunar; urgency=medium

  [Bryan Kemp]
  * Add Support for EV_COMPACT_HASH event type

  [Colin Ian King]
  * ACPICA: Update to version 20221020
  * fwts-test: sync test logs with latest ACPICA

  [Ivan Hu]
  * s3: modify the default sleep type description
  * fwts-test: sync up with the default s3 sleep type description change
  * acpi: rgrt: add test for ACPI RGRT table( mantis 2056)
  * fwts-test: add regression test for RGRT
  * acpi: cedt: add tests for ACPI CEDT table (mantis 2076)
  * fwts-test: add regression tests for CEDT
  * auto-package: mkpackage.sh: add lunar

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 21 Nov 2022 15:31:59 +0800

## fwts 23.07.00

=== debian/changelog ===
fwts (23.07.00-0ubuntu1) mantic; urgency=medium

  [Armin Wolf]
  * acpi/wmi: Add WMI GUID for the dell-wmi-ddv driver
  * acpi/wmi: Check if the mandatory block query method exists
  * acpi/wmi: Fix bug when counting WMI methods
  * fwts_acpica: Remove unused variable "context"

  [Colin Ian King]
  * ACPICA: Update to version 20230628

  [Ivan Hu]
  * lib: framework: remvoe ARM specific for ebbr
  * fwts-test: sync up the removing ARM specific for ebbr
  * cppcheck: fix the cppcheck source link error
  * lib: fwts_oops: fix the WARN_ON warnings in kernel not found
  * debian: control: update uploader
  * debian: control: modify newer dkms dependency
  * auto-packager: mkpackage.sh: remove the control hook
  * lib: fwts_dump_data: add function for simply dump raw data
  * lib: fwts_dump_data: add library function for dumping all raw data with
    prefix
  * acpi: aest: modify the dumping raw data without noisy info
  * fwts-test: sync up aest modify the dumping raw data
  * acpi: mpam: add test for ACPI MPAM table
  * fwts-test: sync up with adding the mpam tests
  * acpi: mpam: test with resource specific data for interconnect location type
  * fwts-test: sync up with test with resource specific data
  * acpi: mpam: fix build fail on bionic
  * uefi: esrt: update the LastAttemptStatus values to UEFI spec 2.10
  * lib: fwts_acpi_object_eval: sync up the AML exceptions from ACPICA
  * debian: update compat level and standards version
  * debian: fix debuild fail for the not installed files
  * debian: fix lintian errors and warnings

  [Mario Limonciello]
  * Increase number of max semaphores to fix OOM crashes on some systems

  [Ákos Nagy]
  * lib: make the return types consistent
 
 -- Ivan Hu <ivan.hu@ubuntu.com>  Fri, 07 Jul 2023 10:37:02 +0800

fwts (23.05.00-0ubuntu1) mantic; urgency=medium

  [Colin Ian King]
  * ACPICA: Update to version 20230331

  [Ivan Hu]
  * dmicheck: extent the dmi_patterns for the default serial number string
  * dmicheck: add more checks for invalid serial number string
  * acpi: cedt: remove unused code
  * acpi: ivrs: add tests for ACPI IVRS table
  * fwts-test: add regression tests for IVRS
  * acpi: button: remove check fixed hardware & control method power buttons
  * lib: fwts_framework: add EBBR to category
  * s3: fix the display time of resume for Timekeeping suspended string missing
  * fwts_framwork: add ebbr test for RISC-V
  * auto-packager: mkpackage.sh: add mantic
  * debian: control: add build depend dh-dkms
  * auto-packager: mkpackage.sh remove the dh-dkms dependency

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 23 May 2023 11:59:34 +0800

fwts (23.03.00-0ubuntu1) lunar; urgency=medium

  [Huacai Chen]
  * Add support for 64 bit LoongArch compilation

  [Ivan Hu]
  * sbbr: add esrt and uefibootpath tests to sbbr option
  * ebbr: add some tests to ebbr option
  * acpi: method: NIH method output buffer should be 4 bytes
  * debian: update copyright
  * dmicheck: fix the length check error for type 9
  * dmicheck: fix the wrong slot height value range
  * dmicheck: fix the extended bios ROM size bit check of type 0
  * dmicheck: add processor family check for type 4
  * dmicheck: add status check for type 4
  * dmicheck: add bit 0 reserved check of the processor characteristics for type 4
  * dmicheck: modify the memory type range check for type 17
  * dmicheck: add some bit 0 reserved checks for type 17
  * dmicheck: update the interface field for type 21
  * dmicheck: update the device type field for type 41
  * dmicheck: update for supporting DMI version to 3.6
  * dmicheck: fix the print format
  * auto-packager: mkpackage: add build depend dh-dkms for lunar

  [Vasiliy Kovalev]
  * libfwtsiasl: fix undefined symbols in shared library

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 27 Mar 2023 12:06:53 +0800
